__scene_objects = {}

def register(name, klass):
    __scene_objects[name] = klass

def defined_objects():
    return __scene_objects.copy()

class Item(object):
    pass

class Object(Item):
    pass

class Scene(object):
    def __init__(self):
        self.cameras = []
        self.lights = []
        self.objects = []

def read(buf):
    try:
        scene = Scene()
        defs = globals().copy()
        for k, v in defined_objects().iteritems(): defs[k] = v
        items = {}
        source = buf.read()
        code = compile(source, source, 'exec')
        exec(code, defs, items)
        for name in items:
            item = items[name]
            item.name = name
            if isinstance(item, Camera):
                scene.cameras.append(item)
            elif isinstance(item, Object):
                scene.objects.append(item)
        return scene

    except IndexError:
        print 'Try: read.py [scenefile]'


import objects
from camera import Camera
